#include<iostream>
using namespace std;
long long st(long long x, int n) {
	if (n==0) return 1;
	else if (n==1) return x;
	else if (n%2==0) return st(x*x,n/2);
	else return x*st(x*x,n/2);
}
int main() {
    ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	long long n, m, i, j, c, s=0, br=1;
	cin >> n >> m;
	long long b[m+1], a[n+1];
	for (i=1; i<=m; i++) cin >> b[i];
	for (i=1; i<=n; i++) a[i]=br++;
	for (i=0; i<=n-m; i++) {
		for (j=1; j<=m; j++)
		a[i+b[j]]=a[i+j];
	}
	cin >> c;
	for (i=1; i<n+1; i++) {
		s+=st(c,i)*a[i];
	}
	cout << s%998244353;
}